searchNodes=[{"doc":"Liquid template renderer for Elixir with 100% compatibility with the Liquid gem by Shopify . Basic Usage iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; { content , _context } = Liquex . render! ( template_ast , %{ &quot;name&quot; =&gt; &quot;World&quot; } ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot; Supported features Currently, all standard Liquid tags, filters, and types are fully supported for liquid prior to 5.0.0. Liquex can be considered a byte for byte drop in replacement of the Liquid gem. Work is under way to implement Liquid 5.x features. Right now, the following features are now included: {% render %} tag What is currently being worked on: {% liquid %} tag Lazy variables Liquex allows resolver functions for variables that may require some extra work to generate. For example, Shopify has variables for things like available products. Pulling all products every time would be too expensive to do on every render. Instead, it would be better to lazily pull that information as needed. Instead of adding the product list to the context variable map, you can add a function to the variable map. If a function is accessed in the variable map, it is executed. products_resolver = fn _parent -&gt; Product . all ( ) end with { :ok , document } &lt;- Liquex . parse ( &quot;There are {{ products.size }} products&quot; ) , { result , _ } &lt;- Liquex . render! ( document , %{ products : products_resolver } ) do result end iex&gt; &quot;There are 5 products&quot; Indifferent access By default, Liquex accesses your maps and structs that may have atom or string (or other type) keys. Liquex will try a string key first. If that fails, it will fall back to using an atom keys. This is similar to how Ruby on Rails handles many of its hashes. This allows you to pass in your structs without having to replace all your keys with string keys. iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; { content , _context } = Liquex . render! ( template_ast , %{ name : &quot;World&quot; } ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot; Caching Liquex has a built in cache used specifically for the render tag currently. When loading a partial/sub-template using the render tag, it will try pulling from the cache associated with the context. By default, caching is disabled, but you may use the built in ETS based cache by configuring it in your context. :ok = Liquex.Cache.SimpleCache . init ( ) context = Context . new ( %{ ... } , cache : Liquex.Cache.SimpleCache ) The simple cache is by definition quite simple. To use a more complete caching system, such as Cachex , you can create a module that implements the Liquex.Cache behaviour. The cache system is very early on. It is expected that it will also be used to memoize some of the variables within your context. Custom filters Liquex contains the full suite of standard Liquid filters, but you may find that there are still filters that you may want to add. Liquex supports adding your own custom filters to the render pipeline. When creating the context for the renderer, set the filter module to your own module. defmodule CustomFilter do # Import all the standard liquid filters use Liquex.Filter def scream ( value , _ ) , do : String . upcase ( value ) &lt;&gt; &quot;!&quot; end context = Liquex.Context . new ( %{ } , filter_module : CustomFilter ) { :ok , template_ast } = Liquex . parse ( &quot;{{&#39;Hello World&#39; | scream}}&quot; { result , _ } = Liquex . render! ( template_ast , context ) result |&gt; to_string ( ) iex&gt; &quot;HELLO WORLD!&quot; Custom tags One of the strong points for Liquex is that the tag parser can be extended to support non-standard tags. For example, Liquid used internally for the Shopify site includes a large range of tags that are not supported by the base Ruby gem. These tags could also be added to Liquex by extending the liquid parser. defmodule CustomTag do @moduledoc false @behaviour Liquex.Tag import NimbleParsec @impl true # Parse &lt;&lt;Custom Tag&gt;&gt; def parse ( ) do text = lookahead_not ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; utf8_char ( [ ] ) |&gt; times ( min : 1 ) |&gt; reduce ( { Kernel , :to_string , [ ] } ) |&gt; tag ( :text ) ignore ( string ( &quot;&lt;&lt;&quot; ) ) |&gt; optional ( text ) |&gt; ignore ( string ( &quot;&gt;&gt;&quot; ) ) end @impl true def render ( contents , context ) do { result , context } = Liquex . render! ( contents , context ) { [ &quot;Custom Tag: &quot; , result ] , context } end end defmodule CustomParser do use Liquex.Parser , tags : [ CustomTag ] end iex&gt; document = Liquex . parse! ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) iex&gt; { result , _ } = Liquex . render! ( document , context ) iex&gt; result |&gt; to_string ( ) &quot; Custom Tag : Hello World Installation Add the package to your mix.exs file. def deps do [ { :liquex , &quot;~&gt; 0.7&quot; } ] end","ref":"Liquex.html","title":"Liquex","type":"module"},{"doc":"Parses a liquid template string using the given parser . Returns a Liquex AST document or the parser error","ref":"Liquex.html#parse/2","title":"Liquex.parse/2","type":"function"},{"doc":"Parses a liquid template string using the given parser . Returns a Liquex AST document or raises an exception. See also parse/2","ref":"Liquex.html#parse!/2","title":"Liquex.parse!/2","type":"function"},{"doc":"","ref":"Liquex.html#render/2","title":"Liquex.render/2","type":"function"},{"doc":"Render a Liquex AST document with the given context","ref":"Liquex.html#render!/2","title":"Liquex.render!/2","type":"function"},{"doc":"","ref":"Liquex.html#t:document_t/0","title":"Liquex.document_t/0","type":"type"},{"doc":"Default file system that throws an error when trying to call render within a template.","ref":"Liquex.BlankFileSystem.html","title":"Liquex.BlankFileSystem","type":"module"},{"doc":"Caching behaviour attached to a Liquex.Context . Currently, caching is only used for partial loading in render tags.","ref":"Liquex.Cache.html","title":"Liquex.Cache","type":"behaviour"},{"doc":"Fetch a value from cache. If the value doesn't exist, run the given function and store the results within the cache.","ref":"Liquex.Cache.html#c:fetch/2","title":"Liquex.Cache.fetch/2","type":"callback"},{"doc":"","ref":"Liquex.Cache.html#t:key/0","title":"Liquex.Cache.key/0","type":"type"},{"doc":"","ref":"Liquex.Cache.html#t:value/0","title":"Liquex.Cache.value/0","type":"type"},{"doc":"Default caching system for Liquex. Always runs the given function and never stores the results.","ref":"Liquex.Cache.DisabledCache.html","title":"Liquex.Cache.DisabledCache","type":"module"},{"doc":"Basic caching system that uses ETS.","ref":"Liquex.Cache.SimpleCache.html","title":"Liquex.Cache.SimpleCache","type":"module"},{"doc":"","ref":"Liquex.Cache.SimpleCache.html#init/0","title":"Liquex.Cache.SimpleCache.init/0","type":"function"},{"doc":"","ref":"Liquex.Collection.html","title":"Liquex.Collection","type":"protocol"},{"doc":"","ref":"Liquex.Collection.html#limit/2","title":"Liquex.Collection.limit/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#offset/2","title":"Liquex.Collection.offset/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#reverse/1","title":"Liquex.Collection.reverse/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort/1","title":"Liquex.Collection.sort/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort/2","title":"Liquex.Collection.sort/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort_case_insensitive/1","title":"Liquex.Collection.sort_case_insensitive/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#sort_case_insensitive/2","title":"Liquex.Collection.sort_case_insensitive/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#to_enumerable/1","title":"Liquex.Collection.to_enumerable/1","type":"function"},{"doc":"","ref":"Liquex.Collection.html#where/2","title":"Liquex.Collection.where/2","type":"function"},{"doc":"","ref":"Liquex.Collection.html#where/3","title":"Liquex.Collection.where/3","type":"function"},{"doc":"","ref":"Liquex.Collection.html#t:t/0","title":"Liquex.Collection.t/0","type":"type"},{"doc":"Context keeps the variable stack and resolves variables, as well as keywords. It also keeps configuration information needed to render a Liquid template, such as filters and the file system. Variables are stored within a few different contexts which each have their own usage and meaning. :environment The environment stores the top level variables defined outside of the liquid templates. These are variables you want to predefine before rendering the templates. Note: these variables are not accessible within nested render tags. :static_environment The static environment is similar to the base environment. The difference is that it has a lower priority for reading than the environment and the variables defined in this context are accessible within nested render tags. Use the static environment if you want global variables accessible across all render tags. :scope The scope is a stack of environments that keep track of variables within various scopes. For example, when entering a for loop, it creates a new scope and pushes it onto the stack. When exiting the for loop, all variables defined within that scope are removed. Scopes have the highest precedence of all the different locations that store variables. Examples iex&gt; context = Liquex.Context . new ( %{ hello : &quot;environment&quot; } ) iex&gt; Access . get ( context , &quot;hello&quot; ) &quot;environment&quot; iex&gt; context = Liquex.Context . new ( %{ } , scope : %{ hello : &quot;scope&quot; } ) iex&gt; Access . get ( context , &quot;hello&quot; ) &quot;scope&quot; iex&gt; context = Liquex.Context . new ( %{ } , static_environment : %{ hello : &quot;static environment&quot; } ) iex&gt; Access . get ( context , &quot;hello&quot; ) &quot;static environment&quot;","ref":"Liquex.Context.html","title":"Liquex.Context","type":"module"},{"doc":"Assign a new variable to the context Set a variable named key with the given value in the current context","ref":"Liquex.Context.html#assign/3","title":"Liquex.Context.assign/3","type":"function"},{"doc":"","ref":"Liquex.Context.html#assign_global/3","title":"Liquex.Context.assign_global/3","type":"function"},{"doc":"Look up variable within the current scope. If the scope does not define the variable, it is then looked up in the environment. Lastly, if that fails, it falls back to the static environment. All variable look ups are indifferent to the key being a string or an atom. Either or can be used to save and store the variables.","ref":"Liquex.Context.html#fetch/2","title":"Liquex.Context.fetch/2","type":"function"},{"doc":"","ref":"Liquex.Context.html#get/3","title":"Liquex.Context.get/3","type":"function"},{"doc":"Callback implementation for Access.get_and_update/3 .","ref":"Liquex.Context.html#get_and_update/3","title":"Liquex.Context.get_and_update/3","type":"function"},{"doc":"Create a new Context using predefined variables map Returns a new context to store the current state of a liquid template during the render phase. Options :static_environment - An unchanging environment scope also accessible from nested render tags. :scope - Initial scope with variables defined as if they were set within the liquid template. :filter_module - Module that will be used for filtering :file_system - File loading module","ref":"Liquex.Context.html#new/2","title":"Liquex.Context.new/2","type":"function"},{"doc":"Create a new context inheriting static environment and options","ref":"Liquex.Context.html#new_isolated_subscope/2","title":"Liquex.Context.new_isolated_subscope/2","type":"function"},{"doc":"Callback implementation for Access.pop/2 .","ref":"Liquex.Context.html#pop/2","title":"Liquex.Context.pop/2","type":"function"},{"doc":"Pop the current scope off the scope stack and throw it away","ref":"Liquex.Context.html#pop_scope/1","title":"Liquex.Context.pop_scope/1","type":"function"},{"doc":"Assign an error to the error logs","ref":"Liquex.Context.html#push_error/2","title":"Liquex.Context.push_error/2","type":"function"},{"doc":"Push a new scope onto the scope stack","ref":"Liquex.Context.html#push_scope/2","title":"Liquex.Context.push_scope/2","type":"function"},{"doc":"","ref":"Liquex.Context.html#t:t/0","title":"Liquex.Context.t/0","type":"type"},{"doc":"Behaviour for file system access used by the render tag.","ref":"Liquex.FileSystem.html","title":"Liquex.FileSystem","type":"protocol"},{"doc":"Read a template from the filesystem","ref":"Liquex.FileSystem.html#read_template_file/2","title":"Liquex.FileSystem.read_template_file/2","type":"function"},{"doc":"","ref":"Liquex.FileSystem.html#t:t/0","title":"Liquex.FileSystem.t/0","type":"type"},{"doc":"Contains all the basic filters for Liquid","ref":"Liquex.Filter.html","title":"Liquex.Filter","type":"behaviour"},{"doc":"Returns the absolute value of value . Examples iex&gt; Liquex.Filter . abs ( - 1 , %{ } ) 1 iex&gt; Liquex.Filter . abs ( 1 , %{ } ) 1 iex&gt; Liquex.Filter . abs ( &quot;-1.1&quot; , %{ } ) 1.1","ref":"Liquex.Filter.html#abs/2","title":"Liquex.Filter.abs/2","type":"function"},{"doc":"Appends text to the end of value Examples iex&gt; Liquex.Filter . append ( &quot;myfile&quot; , &quot;.html&quot; , %{ } ) &quot;myfile.html&quot;","ref":"Liquex.Filter.html#append/3","title":"Liquex.Filter.append/3","type":"function"},{"doc":"","ref":"Liquex.Filter.html#c:apply/3","title":"Liquex.Filter.apply/3","type":"callback"},{"doc":"","ref":"Liquex.Filter.html#apply/4","title":"Liquex.Filter.apply/4","type":"function"},{"doc":"Sets a minimum value Examples iex&gt; Liquex.Filter . at_least ( 3 , 5 , %{ } ) 5 iex&gt; Liquex.Filter . at_least ( 5 , 3 , %{ } ) 5 iex&gt; Liquex.Filter . at_least ( &quot;5&quot; , &quot;3&quot; , %{ } ) 5","ref":"Liquex.Filter.html#at_least/3","title":"Liquex.Filter.at_least/3","type":"function"},{"doc":"Sets a maximum value Examples iex&gt; Liquex.Filter . at_most ( 4 , 5 , %{ } ) 4 iex&gt; Liquex.Filter . at_most ( 4 , 3 , %{ } ) 3 iex&gt; Liquex.Filter . at_most ( &quot;4&quot; , &quot;3&quot; , %{ } ) 3","ref":"Liquex.Filter.html#at_most/3","title":"Liquex.Filter.at_most/3","type":"function"},{"doc":"Capitalizes a string Examples iex&gt; Liquex.Filter . capitalize ( &quot;title&quot; , %{ } ) &quot;Title&quot; iex&gt; Liquex.Filter . capitalize ( &quot;my great title&quot; , %{ } ) &quot;My great title&quot;","ref":"Liquex.Filter.html#capitalize/2","title":"Liquex.Filter.capitalize/2","type":"function"},{"doc":"Rounds value up to the nearest whole number. Liquid tries to convert the input to a number before the filter is applied. Examples iex&gt; Liquex.Filter . ceil ( 1.2 , %{ } ) 2 iex&gt; Liquex.Filter . ceil ( 2.0 , %{ } ) 2 iex&gt; Liquex.Filter . ceil ( 183.357 , %{ } ) 184 iex&gt; Liquex.Filter . ceil ( &quot;3.5&quot; , %{ } ) 4","ref":"Liquex.Filter.html#ceil/2","title":"Liquex.Filter.ceil/2","type":"function"},{"doc":"Removes any nil values from an array. Examples iex&gt; Liquex.Filter . compact ( [ 1 , 2 , nil , 3 ] , %{ } ) [ 1 , 2 , 3 ] iex&gt; Liquex.Filter . compact ( [ 1 , 2 , 3 ] , %{ } ) [ 1 , 2 , 3 ]","ref":"Liquex.Filter.html#compact/2","title":"Liquex.Filter.compact/2","type":"function"},{"doc":"Concatenates (joins together) multiple arrays. The resulting array contains all the items Examples iex&gt; Liquex.Filter . concat ( [ 1 , 2 ] , [ 3 , 4 ] , %{ } ) [ 1 , 2 , 3 , 4 ]","ref":"Liquex.Filter.html#concat/3","title":"Liquex.Filter.concat/3","type":"function"},{"doc":"Converts value timestamp into another date format . The format for this syntax is the same as strftime. The input uses the same format as Ruby’s Time.parse. Examples iex&gt; Liquex.Filter . date ( ~D[2000-01-01] , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;2000-01-01&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;January 1, 2000&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/01/2000&quot; iex&gt; Liquex.Filter . date ( &quot;1/2/2000&quot; , &quot;%m/%d/%Y&quot; , %{ } ) &quot;01/02/2000&quot; iex&gt; Liquex.Filter . date ( &quot;March 14, 2016&quot; , &quot;%b %d, %y&quot; , %{ } ) &quot;Mar 14, 16&quot;","ref":"Liquex.Filter.html#date/3","title":"Liquex.Filter.date/3","type":"function"},{"doc":"Allows you to specify a fallback in case a value doesn’t exist. default will show its value if the left side is nil, false, or empty. Examples iex&gt; Liquex.Filter . default ( &quot;1.99&quot; , &quot;2.99&quot; , %{ } ) &quot;1.99&quot; iex&gt; Liquex.Filter . default ( &quot;&quot; , &quot;2.99&quot; , %{ } ) &quot;2.99&quot;","ref":"Liquex.Filter.html#default/3","title":"Liquex.Filter.default/3","type":"function"},{"doc":"Divides a number by another number. Examples The result is rounded down to the nearest integer (that is, the floor) if the divisor is an integer. iex&gt; Liquex.Filter . divided_by ( 16 , 4 , %{ } ) 4 iex&gt; Liquex.Filter . divided_by ( 5 , 3 , %{ } ) 1 iex&gt; Liquex.Filter . divided_by ( 20 , 7.0 , %{ } ) 2.857142857142857","ref":"Liquex.Filter.html#divided_by/3","title":"Liquex.Filter.divided_by/3","type":"function"},{"doc":"Makes each character in a string lowercase. It has no effect on strings which are already all lowercase. Examples iex&gt; Liquex.Filter . downcase ( &quot;Parker Moore&quot; , %{ } ) &quot;parker moore&quot; iex&gt; Liquex.Filter . downcase ( &quot;apple&quot; , %{ } ) &quot;apple&quot;","ref":"Liquex.Filter.html#downcase/2","title":"Liquex.Filter.downcase/2","type":"function"},{"doc":"Escapes a string by replacing characters with escape sequences (so that the string can be used in a URL, for example). It doesn’t change strings that don’t have anything to escape. Examples iex&gt; Liquex.Filter . escape ( &quot;Have you read &#39;James &amp; the Giant Peach&#39;?&quot; , %{ } ) &quot;Have you read &amp;apos;James &amp;amp; the Giant Peach&amp;apos;?&quot; iex&gt; Liquex.Filter . escape ( &quot;Tetsuro Takara&quot; , %{ } ) &quot;Tetsuro Takara&quot;","ref":"Liquex.Filter.html#escape/2","title":"Liquex.Filter.escape/2","type":"function"},{"doc":"Escapes a string by replacing characters with escape sequences (so that the string can be used in a URL, for example). It doesn’t change strings that don’t have anything to escape. Examples iex&gt; Liquex.Filter . escape_once ( &quot;1 &amp;lt; 2 &amp;amp; 3&quot; , %{ } ) &quot;1 &amp;lt; 2 &amp;amp; 3&quot;","ref":"Liquex.Filter.html#escape_once/2","title":"Liquex.Filter.escape_once/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#filter_name/1","title":"Liquex.Filter.filter_name/1","type":"function"},{"doc":"Returns the first item of an array. Examples iex&gt; Liquex.Filter . first ( [ 1 , 2 , 3 ] , %{ } ) 1 iex&gt; Liquex.Filter . first ( [ ] , %{ } ) nil","ref":"Liquex.Filter.html#first/2","title":"Liquex.Filter.first/2","type":"function"},{"doc":"Rounds the input down to the nearest whole number. Liquid tries to convert the input to a number before the filter is applied. Examples iex&gt; Liquex.Filter . floor ( 1.2 , %{ } ) 1 iex&gt; Liquex.Filter . floor ( 2.0 , %{ } ) 2","ref":"Liquex.Filter.html#floor/2","title":"Liquex.Filter.floor/2","type":"function"},{"doc":"Combines the items in values into a single string using joiner as a separator. Examples iex&gt; Liquex.Filter . join ( ~w(John Paul George Ringo) , &quot; and &quot; , %{ } ) &quot;John and Paul and George and Ringo&quot;","ref":"Liquex.Filter.html#join/3","title":"Liquex.Filter.join/3","type":"function"},{"doc":"Returns the last item of arr . Examples iex&gt; Liquex.Filter . last ( [ 1 , 2 , 3 ] , %{ } ) 3 iex&gt; Liquex.Filter . first ( [ ] , %{ } ) nil","ref":"Liquex.Filter.html#last/2","title":"Liquex.Filter.last/2","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from the left side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . lstrip ( &quot; So much room for activities! &quot; , %{ } ) &quot;So much room for activities! &quot;","ref":"Liquex.Filter.html#lstrip/2","title":"Liquex.Filter.lstrip/2","type":"function"},{"doc":"Creates an array ( arr ) of values by extracting the values of a named property from another object ( key ). Examples iex&gt; Liquex.Filter . map ( [ %{ &quot;a&quot; =&gt; 1 } , %{ &quot;a&quot; =&gt; 2 , &quot;b&quot; =&gt; 1 } ] , &quot;a&quot; , %{ } ) [ 1 , 2 ]","ref":"Liquex.Filter.html#map/3","title":"Liquex.Filter.map/3","type":"function"},{"doc":"Subtracts a number from another number. Examples iex&gt; Liquex.Filter . minus ( 4 , 2 , %{ } ) 2 iex&gt; Liquex.Filter . minus ( 183.357 , 12 , %{ } ) 171.357","ref":"Liquex.Filter.html#minus/3","title":"Liquex.Filter.minus/3","type":"function"},{"doc":"Returns the remainder of a division operation. Examples iex&gt; Liquex.Filter . modulo ( 3 , 2 , %{ } ) 1 iex&gt; Liquex.Filter . modulo ( 183.357 , 12 , %{ } ) 3.357","ref":"Liquex.Filter.html#modulo/3","title":"Liquex.Filter.modulo/3","type":"function"},{"doc":"Replaces every newline ( ) in a string with an HTML line break (&lt;br /&gt;). Examples iex&gt; Liquex.Filter . newline_to_br ( &quot; \\n Hello \\n there \\n &quot; , %{ } ) &quot;&lt;br /&gt; \\n Hello&lt;br /&gt; \\n there&lt;br /&gt; \\n &quot;","ref":"Liquex.Filter.html#newline_to_br/2","title":"Liquex.Filter.newline_to_br/2","type":"function"},{"doc":"Adds a number to another number. Examples iex&gt; Liquex.Filter . plus ( 4 , 2 , %{ } ) 6 iex&gt; Liquex.Filter . plus ( 183.357 , 12 , %{ } ) 195.357","ref":"Liquex.Filter.html#plus/3","title":"Liquex.Filter.plus/3","type":"function"},{"doc":"Adds the specified string to the beginning of another string. Examples iex&gt; Liquex.Filter . prepend ( &quot;apples, oranges, and bananas&quot; , &quot;Some fruit: &quot; , %{ } ) &quot;Some fruit: apples, oranges, and bananas&quot; iex&gt; Liquex.Filter . prepend ( &quot;/index.html&quot; , &quot;example.com&quot; , %{ } ) &quot;example.com/index.html&quot;","ref":"Liquex.Filter.html#prepend/3","title":"Liquex.Filter.prepend/3","type":"function"},{"doc":"Removes every occurrence of the specified substring from a string. Examples iex&gt; Liquex.Filter . remove ( &quot;I strained to see the train through the rain&quot; , &quot;rain&quot; , %{ } ) &quot;I sted to see the t through the &quot;","ref":"Liquex.Filter.html#remove/3","title":"Liquex.Filter.remove/3","type":"function"},{"doc":"Removes every occurrence of the specified substring from a string. Examples iex&gt; Liquex.Filter . remove_first ( &quot;I strained to see the train through the rain&quot; , &quot;rain&quot; , %{ } ) &quot;I sted to see the train through the rain&quot;","ref":"Liquex.Filter.html#remove_first/3","title":"Liquex.Filter.remove_first/3","type":"function"},{"doc":"Replaces every occurrence of the first argument in a string with the second argument. Examples iex&gt; Liquex.Filter . replace ( &quot;Take my protein pills and put my helmet on&quot; , &quot;my&quot; , &quot;your&quot; , %{ } ) &quot;Take your protein pills and put your helmet on&quot;","ref":"Liquex.Filter.html#replace/4","title":"Liquex.Filter.replace/4","type":"function"},{"doc":"Replaces only the first occurrence of the first argument in a string with the second argument. Examples iex&gt; Liquex.Filter . replace_first ( &quot;Take my protein pills and put my helmet on&quot; , &quot;my&quot; , &quot;your&quot; , %{ } ) &quot;Take your protein pills and put my helmet on&quot;","ref":"Liquex.Filter.html#replace_first/4","title":"Liquex.Filter.replace_first/4","type":"function"},{"doc":"Reverses the order of the items in an array. reverse cannot reverse a string. Examples iex&gt; Liquex.Filter . reverse ( ~w(apples oranges peaches plums) , %{ } ) [ &quot;plums&quot; , &quot;peaches&quot; , &quot;oranges&quot; , &quot;apples&quot; ]","ref":"Liquex.Filter.html#reverse/2","title":"Liquex.Filter.reverse/2","type":"function"},{"doc":"Rounds a number to the nearest integer or, if a number is passed as an argument, to that number of decimal places. Examples iex&gt; Liquex.Filter . round ( 1 , %{ } ) 1 iex&gt; Liquex.Filter . round ( 1.2 , %{ } ) 1 iex&gt; Liquex.Filter . round ( 2.7 , %{ } ) 3 iex&gt; Liquex.Filter . round ( 183.357 , 2 , %{ } ) 183.36","ref":"Liquex.Filter.html#round/3","title":"Liquex.Filter.round/3","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from the right side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . rstrip ( &quot; So much room for activities! &quot; , %{ } ) &quot; So much room for activities!&quot;","ref":"Liquex.Filter.html#rstrip/2","title":"Liquex.Filter.rstrip/2","type":"function"},{"doc":"Returns the number of characters in a string or the number of items in an array. Examples iex&gt; Liquex.Filter . size ( &quot;Ground control to Major Tom.&quot; , %{ } ) 28 iex&gt; Liquex.Filter . size ( ~w(apples oranges peaches plums) , %{ } ) 4","ref":"Liquex.Filter.html#size/2","title":"Liquex.Filter.size/2","type":"function"},{"doc":"Returns a substring of 1 character beginning at the index specified by the first argument. An optional second argument specifies the length of the substring to be returned. Examples iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 0 , %{ } ) &quot;L&quot; iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 2 , %{ } ) &quot;q&quot; iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , 2 , 5 , %{ } ) &quot;quid&quot; If the first argument is a negative number, the indices are counted from the end of the string: Examples iex&gt; Liquex.Filter . slice ( &quot;Liquid&quot; , - 3 , 2 , %{ } ) &quot;ui&quot;","ref":"Liquex.Filter.html#slice/4","title":"Liquex.Filter.slice/4","type":"function"},{"doc":"Sorts items in an array in case-sensitive order. Examples iex&gt; Liquex.Filter . sort ( [ &quot;zebra&quot; , &quot;octopus&quot; , &quot;giraffe&quot; , &quot;Sally Snake&quot; ] , %{ } ) [ &quot;Sally Snake&quot; , &quot;giraffe&quot; , &quot;octopus&quot; , &quot;zebra&quot; ]","ref":"Liquex.Filter.html#sort/2","title":"Liquex.Filter.sort/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#sort/3","title":"Liquex.Filter.sort/3","type":"function"},{"doc":"Sorts items in an array in case-insensitive order. Examples iex&gt; Liquex.Filter . sort_natural ( [ &quot;zebra&quot; , &quot;octopus&quot; , &quot;giraffe&quot; , &quot;Sally Snake&quot; ] , %{ } ) [ &quot;giraffe&quot; , &quot;octopus&quot; , &quot;Sally Snake&quot; , &quot;zebra&quot; ]","ref":"Liquex.Filter.html#sort_natural/2","title":"Liquex.Filter.sort_natural/2","type":"function"},{"doc":"","ref":"Liquex.Filter.html#sort_natural/3","title":"Liquex.Filter.sort_natural/3","type":"function"},{"doc":"Divides a string into an array using the argument as a separator. split is commonly used to convert comma-separated items from a string to an array. Examples iex&gt; Liquex.Filter . split ( &quot;John, Paul, George, Ringo&quot; , &quot;, &quot; , %{ } ) [ &quot;John&quot; , &quot;Paul&quot; , &quot;George&quot; , &quot;Ringo&quot; ]","ref":"Liquex.Filter.html#split/3","title":"Liquex.Filter.split/3","type":"function"},{"doc":"Removes all whitespace (tabs, spaces, and newlines) from both the left and right side of a string. It does not affect spaces between words. Examples iex&gt; Liquex.Filter . strip ( &quot; So much room for activities! &quot; , %{ } ) &quot;So much room for activities!&quot;","ref":"Liquex.Filter.html#strip/2","title":"Liquex.Filter.strip/2","type":"function"},{"doc":"Removes any HTML tags from a string. Examples iex&gt; Liquex.Filter . strip_html ( &quot;Have &lt;em&gt;you&lt;/em&gt; read &lt;strong&gt;Ulysses&lt;/strong&gt;?&quot; , %{ } ) &quot;Have you read Ulysses?&quot;","ref":"Liquex.Filter.html#strip_html/2","title":"Liquex.Filter.strip_html/2","type":"function"},{"doc":"Removes any newline characters (line breaks) from a string. Examples iex&gt; Liquex.Filter . strip_newlines ( &quot;Hello \\n there&quot; , %{ } ) &quot;Hellothere&quot;","ref":"Liquex.Filter.html#strip_newlines/2","title":"Liquex.Filter.strip_newlines/2","type":"function"},{"doc":"Multiplies a number by another number. Examples iex&gt; Liquex.Filter . times ( 3 , 4 , %{ } ) 12 iex&gt; Liquex.Filter . times ( 24 , 7 , %{ } ) 168 iex&gt; Liquex.Filter . times ( 183.357 , 12 , %{ } ) 2200.284","ref":"Liquex.Filter.html#times/3","title":"Liquex.Filter.times/3","type":"function"},{"doc":"Shortens a string down to the number of characters passed as an argument. If the specified number of characters is less than the length of the string, an ellipsis (…) is appended to the string and is included in the character count. Examples iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 20 , %{ } ) &quot;Ground control to...&quot; iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 25 , &quot;, and so on&quot; , %{ } ) &quot;Ground control, and so on&quot; iex&gt; Liquex.Filter . truncate ( &quot;Ground control to Major Tom.&quot; , 20 , &quot;&quot; , %{ } ) &quot;Ground control to Ma&quot;","ref":"Liquex.Filter.html#truncate/4","title":"Liquex.Filter.truncate/4","type":"function"},{"doc":"Shortens a string down to the number of characters passed as an argument. If the specified number of characters is less than the length of the string, an ellipsis (…) is appended to the string and is included in the character count. Examples iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , %{ } ) &quot;Ground control to...&quot; iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , &quot;--&quot; , %{ } ) &quot;Ground control to--&quot; iex&gt; Liquex.Filter . truncatewords ( &quot;Ground control to Major Tom.&quot; , 3 , &quot;&quot; , %{ } ) &quot;Ground control to&quot;","ref":"Liquex.Filter.html#truncatewords/4","title":"Liquex.Filter.truncatewords/4","type":"function"},{"doc":"Removes any duplicate elements in an array. Examples iex&gt; Liquex.Filter . uniq ( ~w(ants bugs bees bugs ants) , %{ } ) [ &quot;ants&quot; , &quot;bugs&quot; , &quot;bees&quot; ]","ref":"Liquex.Filter.html#uniq/2","title":"Liquex.Filter.uniq/2","type":"function"},{"doc":"Makes each character in a string uppercase. It has no effect on strings which are already all uppercase. Examples iex&gt; Liquex.Filter . upcase ( &quot;Parker Moore&quot; , %{ } ) &quot;PARKER MOORE&quot; iex&gt; Liquex.Filter . upcase ( &quot;APPLE&quot; , %{ } ) &quot;APPLE&quot;","ref":"Liquex.Filter.html#upcase/2","title":"Liquex.Filter.upcase/2","type":"function"},{"doc":"Decodes a string that has been encoded as a URL or by url_encode/2. Examples iex&gt; Liquex.Filter . url_decode ( &quot;%27Stop%21%27+said+Fred&quot; , %{ } ) &quot;&#39;Stop!&#39; said Fred&quot;","ref":"Liquex.Filter.html#url_decode/2","title":"Liquex.Filter.url_decode/2","type":"function"},{"doc":"Decodes a string that has been encoded as a URL or by url_encode/2. Examples iex&gt; Liquex.Filter . url_encode ( &quot;john@liquid.com&quot; , %{ } ) &quot;john%40liquid.com&quot; iex&gt; Liquex.Filter . url_encode ( &quot;Tetsuro Takara&quot; , %{ } ) &quot;Tetsuro+Takara&quot;","ref":"Liquex.Filter.html#url_encode/2","title":"Liquex.Filter.url_encode/2","type":"function"},{"doc":"Creates an array including only the objects with a given truthy property value Examples iex&gt; Liquex.Filter . where ( [ %{ &quot;b&quot; =&gt; true , &quot;value&quot; =&gt; 1 } , %{ &quot;b&quot; =&gt; 1 , &quot;value&quot; =&gt; 2 } , %{ &quot;b&quot; =&gt; false , &quot;value&quot; =&gt; 3 } ] , &quot;b&quot; , %{ } ) [ %{ &quot;b&quot; =&gt; true , &quot;value&quot; =&gt; 1 } , %{ &quot;b&quot; =&gt; 1 , &quot;value&quot; =&gt; 2 } ]","ref":"Liquex.Filter.html#where/3","title":"Liquex.Filter.where/3","type":"function"},{"doc":"Creates an array including only the objects with a given property value, or any truthy value by default. Examples iex&gt; Liquex.Filter . where ( [ %{ &quot;b&quot; =&gt; 2 } , %{ &quot;b&quot; =&gt; 1 } ] , &quot;b&quot; , 1 , %{ } ) [ %{ &quot;b&quot; =&gt; 1 } ]","ref":"Liquex.Filter.html#where/4","title":"Liquex.Filter.where/4","type":"function"},{"doc":"","ref":"Liquex.Filter.html#t:filter_t/0","title":"Liquex.Filter.filter_t/0","type":"type"},{"doc":"This implements an abstract file system which retrieves template files named in a manner similar to liquid, ie. with the template name prefixed with an underscore. The extension &quot;.liquid&quot; is also added. For security reasons, template paths are only allowed to contain letters, numbers, and underscore. Example: iex&gt; file_system = Liquex.LocalFileSystem.new(&quot;/some/path&quot;) iex&gt; Liquex.LocalFileSystem.full_path(file_system, &quot;mypartial&quot;) &quot;/some/path/_mypartial.liquid&quot; Optionally in the second argument you can specify a custom pattern for template filenames. %s is replaced with the template name. Default pattern is &quot;_%s.liquid&quot;. Example: iex&gt; file_system = Liquex.LocalFileSystem.new(&quot;/some/path&quot;, &quot;%s.html&quot;) iex&gt; Liquex.LocalFileSystem.full_path(file_system, &quot;mypartial&quot;) &quot;/some/path/mypartial.html&quot;","ref":"Liquex.LocalFileSystem.html","title":"Liquex.LocalFileSystem","type":"module"},{"doc":"","ref":"Liquex.LocalFileSystem.html#full_path/2","title":"Liquex.LocalFileSystem.full_path/2","type":"function"},{"doc":"","ref":"Liquex.LocalFileSystem.html#new/2","title":"Liquex.LocalFileSystem.new/2","type":"function"},{"doc":"","ref":"Liquex.LocalFileSystem.html#t:t/0","title":"Liquex.LocalFileSystem.t/0","type":"type"},{"doc":"Liquid parser","ref":"Liquex.Parser.html","title":"Liquex.Parser","type":"module"},{"doc":"Helper parsers for parsing fields","ref":"Liquex.Parser.Field.html","title":"Liquex.Parser.Field","type":"module"},{"doc":"Parses a field Examples * &quot;my_variable&quot; * &quot;my_variable.child_value&quot; * &quot;my_variable[0]&quot; * &quot;my_variable.child.value[3]&quot;","ref":"Liquex.Parser.Field.html#field/1","title":"Liquex.Parser.Field.field/1","type":"function"},{"doc":"Parses an identifier Identifiers can start with any letter or underscore. The remaining characters may include digits May end in a question mark (?) Examples * &quot;my_variable&quot; * &quot;is_valid?&quot; * &quot;variable_1&quot;","ref":"Liquex.Parser.Field.html#identifier/1","title":"Liquex.Parser.Field.identifier/1","type":"function"},{"doc":"Helper parsers for parsing literal values in Liquid","ref":"Liquex.Parser.Literal.html","title":"Liquex.Parser.Literal","type":"module"},{"doc":"Parses a literal Examples * &quot;true&quot; * &quot;false&quot; * &quot;nil&quot; * &quot;3.14&quot; * &quot;3&quot; * &quot;&#39;Hello World!&#39;&quot; * &quot;&quot; Hello World ! &quot;&quot;","ref":"Liquex.Parser.Literal.html#literal/1","title":"Liquex.Parser.Literal.literal/1","type":"function"},{"doc":"Parses not line breaking white space, given a minimum. Examples * &quot; &quot; * &quot; &quot;","ref":"Liquex.Parser.Literal.html#non_breaking_whitespace/2","title":"Liquex.Parser.Literal.non_breaking_whitespace/2","type":"function"},{"doc":"Parses a single or double quoted string. Strings may have escaped quotes within them. Examples Examples here include the quotes as given, as opposed to other examples. * &quot;Hello World&quot; * &#39;Hello World&#39; * &quot;Hello &quot; World &quot;&quot; * &#39;Hello &quot;World&quot;&#39; * &#39;Hello &#39; World &#39;&#39;","ref":"Liquex.Parser.Literal.html#quoted_string/0","title":"Liquex.Parser.Literal.quoted_string/0","type":"function"},{"doc":"Parses a range Examples * &quot;(1..5)&quot; * &quot;(1..num)&quot;","ref":"Liquex.Parser.Literal.html#range/1","title":"Liquex.Parser.Literal.range/1","type":"function"},{"doc":"Parses everything outside of the Liquid tags. We call this text but it's any unstructed data not specifically parsed by Liquex.","ref":"Liquex.Parser.Literal.html#text/1","title":"Liquex.Parser.Literal.text/1","type":"function"},{"doc":"Parses white space, given a minimum. Examples * &quot; &quot; * &quot; &quot;","ref":"Liquex.Parser.Literal.html#whitespace/2","title":"Liquex.Parser.Literal.whitespace/2","type":"function"},{"doc":"Helper methods for parsing object tags and arguments used by objects","ref":"Liquex.Parser.Object.html","title":"Liquex.Parser.Object","type":"module"},{"doc":"Parse arguments. Arguments are key/value pairs, but a key may have multiple values separated by commas. Examples * &quot;img_url: &#39;400x400&#39;, crop: &#39;bottom&#39;, filter: &#39;blur&#39;&quot; * &quot;img_size: 800, 600&quot;","ref":"Liquex.Parser.Object.html#arguments/1","title":"Liquex.Parser.Object.arguments/1","type":"function"},{"doc":"Parses closing object tag with white space removing. Examples * &quot;-}} &quot;","ref":"Liquex.Parser.Object.html#close_object_remove_whitespace/1","title":"Liquex.Parser.Object.close_object_remove_whitespace/1","type":"function"},{"doc":"Parses filter that starts with a pipe Examples * &quot;| sort&quot; * &quot;| at_most: 5&quot;","ref":"Liquex.Parser.Object.html#filter/1","title":"Liquex.Parser.Object.filter/1","type":"function"},{"doc":"Parse keyword field Examples * &quot;key: value&quot;","ref":"Liquex.Parser.Object.html#keyword_field/1","title":"Liquex.Parser.Object.keyword_field/1","type":"function"},{"doc":"","ref":"Liquex.Parser.Object.html#keyword_fields/1","title":"Liquex.Parser.Object.keyword_fields/1","type":"function"},{"doc":"Parses object. May contain arguments, literals, and filters. It special cases space removing tags such as {{- and -}} to properly remove any spaces leading and trailing spaces if requested. Examples * &quot;{{ &#39;hello world&#39; }}&quot; * &quot;{{ 5 + 5 }}&quot; * &quot;{{ variable_a | at_most: 5 }}&quot; * &quot;{{- my_array | sort -}}&quot;","ref":"Liquex.Parser.Object.html#object/1","title":"Liquex.Parser.Object.object/1","type":"function"},{"doc":"Helper methods for parsing tags","ref":"Liquex.Parser.Tag.html","title":"Liquex.Parser.Tag","type":"module"},{"doc":"Parse close tags Examples * &quot;%}&quot; * &quot;-%} &quot;","ref":"Liquex.Parser.Tag.html#close_tag/1","title":"Liquex.Parser.Tag.close_tag/1","type":"function"},{"doc":"Read to end of a line within a liquid tag. Reads to end of line (&quot;\\r&quot; and/or &quot;\\n&quot;) or to a closing tag &quot;%}&quot;.","ref":"Liquex.Parser.Tag.html#end_liquid_line/1","title":"Liquex.Parser.Tag.end_liquid_line/1","type":"function"},{"doc":"Parse tag with no expression Examples * &quot;{% if a == 5 %}&quot; * &quot;{% elsif b &gt;= 10 and a &lt; 4 %}&quot;","ref":"Liquex.Parser.Tag.html#expression_tag/2","title":"Liquex.Parser.Tag.expression_tag/2","type":"function"},{"doc":"","ref":"Liquex.Parser.Tag.html#liquid_tag_directive/2","title":"Liquex.Parser.Tag.liquid_tag_directive/2","type":"function"},{"doc":"","ref":"Liquex.Parser.Tag.html#liquid_tag_expression/2","title":"Liquex.Parser.Tag.liquid_tag_expression/2","type":"function"},{"doc":"Parse open tags Examples * &quot;{%&quot; * &quot;{%-&quot;","ref":"Liquex.Parser.Tag.html#open_tag/1","title":"Liquex.Parser.Tag.open_tag/1","type":"function"},{"doc":"Parse basic tag with no arguments Examples * &quot;{% break %}&quot; * &quot;{% endfor %}&quot;","ref":"Liquex.Parser.Tag.html#tag_directive/2","title":"Liquex.Parser.Tag.tag_directive/2","type":"function"},{"doc":"Helper methods for maps","ref":"Liquex.Represent.html","title":"Liquex.Represent","type":"module"},{"doc":"Expands a previously represented object. Useful when the represented object contains lazy fields. This can be useful for generating JSON values from a represented object. For example, if you had a dump filter that dumped a value to the page as JSON, you would use this function so that lazy functions get represented correctly instead of as functions.","ref":"Liquex.Represent.html#expand/1","title":"Liquex.Represent.expand/1","type":"function"},{"doc":"Convert any object and deeply maps atom keys to strings The value deep determines if it should eagerly represent the object. If set to false, it will return a function for any nested objects. Lazy values are automatically evaluated in the Liquid rendering engine.","ref":"Liquex.Represent.html#represent/2","title":"Liquex.Represent.represent/2","type":"function"},{"doc":"","ref":"Liquex.Representable.html","title":"Liquex.Representable","type":"protocol"},{"doc":"","ref":"Liquex.Representable.html#is_lazy/1","title":"Liquex.Representable.is_lazy/1","type":"function"},{"doc":"","ref":"Liquex.Representable.html#represent/2","title":"Liquex.Representable.represent/2","type":"function"},{"doc":"","ref":"Liquex.Representable.html#t:t/0","title":"Liquex.Representable.t/0","type":"type"},{"doc":"Behaviour for building a tag parser and renderer in Liquex. To build a custom tag, create a new module and implement the Liquex.Tag behaviour. defmodule CustomTag do @behaviour Liquex.Tag import NimbleParsec @impl true # Parse &lt;&lt;Custom Tag&gt;&gt; def parse ( ) do text = lookahead_not ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; utf8_char ( [ ] ) |&gt; times ( min : 1 ) |&gt; reduce ( { Kernel , :to_string , [ ] } ) |&gt; tag ( :text ) combinator |&gt; ignore ( string ( &quot;&lt;&lt;&quot; ) ) |&gt; optional ( text ) |&gt; ignore ( string ( &quot;&gt;&gt;&quot; ) ) end @impl true def render ( contents , context ) do { result , context } = Liquex.Render . render! ( contents , context ) { [ &quot;Custom Tag: &quot; , result ] , context } end end You will then have to create a new parser to parse any custom tags. defmodule CustomParser do use Liquex.Parser , tags : [ CustomTag , OtherTag ] end From there, you can parse and render your liquid content. { :ok , document } = Liquex . parse ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) { result , _ } = Liquex . render! ( document , context )","ref":"Liquex.Tag.html","title":"Liquex.Tag","type":"behaviour"},{"doc":"Returns a NimbleParsec expression to parse a tag.","ref":"Liquex.Tag.html#c:parse/0","title":"Liquex.Tag.parse/0","type":"callback"},{"doc":"Returns a NimbleParsec expression to parse a tag within a liquid expression tag. Example { % liquid echo &quot;Hello World!&quot; % }","ref":"Liquex.Tag.html#c:parse_liquid_tag/0","title":"Liquex.Tag.parse_liquid_tag/0","type":"callback"},{"doc":"Render the tag built by the parser defined in parse/0","ref":"Liquex.Tag.html#c:render/2","title":"Liquex.Tag.render/2","type":"callback"},{"doc":"Creates a new named variable. Input { % assign my_variable = false % } { % if my_variable != true % } This statement is valid . { % endif % } Output This statement is valid . Wrap a value in quotations &quot; to save it as a string variable. Input { % assign foo = &quot;bar&quot; % } { { foo } } Output bar","ref":"Liquex.Tag.AssignTag.html","title":"Liquex.Tag.AssignTag","type":"module"},{"doc":"","ref":"Liquex.Tag.AssignTag.html#assign_contents/1","title":"Liquex.Tag.AssignTag.assign_contents/1","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.AssignTag.html#parse/0","title":"Liquex.Tag.AssignTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.AssignTag.html#parse_liquid_tag/0","title":"Liquex.Tag.AssignTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.AssignTag.html#render/2","title":"Liquex.Tag.AssignTag.render/2","type":"function"},{"doc":"Causes the loop to stop iterating when it encounters the break tag. Input { % for i in ( 1 .. 5 ) % } { % if i == 4 % } { % break % } { % else % } { { i } } { % endif % } { % endfor % } Output 1 2 3","ref":"Liquex.Tag.BreakTag.html","title":"Liquex.Tag.BreakTag","type":"module"},{"doc":"Captures the string inside of the opening and closing tags and assigns it to a variable. Variables created using capture are stored as strings. Input { % capture my_variable % } I am being captured . { % endcapture % } { { my_variable } } Output I am being captured . Using capture, you can create complex strings using other variables created with assign. Input { % assign favorite_food = &quot;pizza&quot; % } { % assign age = 35 % } { % capture about_me % } I am { { age } } and my favorite food is { { favorite_food } } . { % endcapture % } { { about_me } } Output I am 35 and my favourite food is pizza .","ref":"Liquex.Tag.CaptureTag.html","title":"Liquex.Tag.CaptureTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.CaptureTag.html#parse/0","title":"Liquex.Tag.CaptureTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.CaptureTag.html#render/2","title":"Liquex.Tag.CaptureTag.render/2","type":"function"},{"doc":"Creates a switch statement to execute a particular block of code when a variable has a specified value. case initializes the switch statement, and when statements define the various conditions. An optional else statement at the end of the case provides code to execute if none of the conditions are met. Input { % assign handle = &quot;cake&quot; % } { % case handle % } { % when &quot;cake&quot; % } This is a cake { % when &quot;cookie&quot; , &quot;biscuit&quot; % } This is a cookie { % else % } This is not a cake nor a cookie { % endcase % } Output This is a cake","ref":"Liquex.Tag.CaseTag.html","title":"Liquex.Tag.CaseTag","type":"module"},{"doc":"","ref":"Liquex.Tag.CaseTag.html#else_tag/0","title":"Liquex.Tag.CaseTag.else_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.CaseTag.html#parse/0","title":"Liquex.Tag.CaseTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.CaseTag.html#parse_liquid_tag/0","title":"Liquex.Tag.CaseTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.CaseTag.html#render/2","title":"Liquex.Tag.CaseTag.render/2","type":"function"},{"doc":"Allows you to leave un-rendered code inside a Liquid template. Any text within the opening and closing comment blocks will not be printed, and any Liquid code within will not be executed. Input { % assign verb = &quot;turned&quot; % } { % comment % } { % assign verb = &quot;converted&quot; % } { % endcomment % } Anything you put between { % comment % } and { % endcomment % } tags is { { verb } } into a comment . Output Anything you put between tags is turned into a comment .","ref":"Liquex.Tag.CommentTag.html","title":"Liquex.Tag.CommentTag","type":"module"},{"doc":"Causes the loop to skip the current iteration when it encounters the continue tag. Input { % for i in ( 1 .. 5 ) % } { % if i == 4 % } { % continue % } { % else % } { { i } } { % endif % } { % endfor % } Output 1 2 3 5","ref":"Liquex.Tag.ContinueTag.html","title":"Liquex.Tag.ContinueTag","type":"module"},{"doc":"Loops through a group of strings and prints them in the order that they were passed as arguments. Each time cycle is called, the next string argument is printed. cycle must be used within a for loop block. Input { % cycle &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } Output one two three one Uses for cycle include: applying odd/even classes to rows in a table applying a unique class to the last product thumbnail in a row cycle (parameters) cycle accepts a “cycle group” parameter in cases where you need multiple cycle blocks in one template. If no name is supplied for the cycle group, then it is assumed that multiple calls with the same parameters are one group. Input { % cycle &quot;first&quot; : &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;second&quot; : &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;second&quot; : &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } { % cycle &quot;first&quot; : &quot;one&quot; , &quot;two&quot; , &quot;three&quot; % } Output one one two two","ref":"Liquex.Tag.CycleTag.html","title":"Liquex.Tag.CycleTag","type":"module"},{"doc":"","ref":"Liquex.Tag.CycleTag.html#do_parse_cycle/1","title":"Liquex.Tag.CycleTag.do_parse_cycle/1","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.CycleTag.html#parse/0","title":"Liquex.Tag.CycleTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.CycleTag.html#parse_liquid_tag/0","title":"Liquex.Tag.CycleTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.CycleTag.html#render/2","title":"Liquex.Tag.CycleTag.render/2","type":"function"},{"doc":"Outputs an expression in the rendered HTML. This is identical to wrapping an expression in {{ and }}, but works inside liquid tags and supports filters. Input { % liquid for product in collection . products echo product . title | capitalize endfor % } Output Hat Shirt Pants","ref":"Liquex.Tag.EchoTag.html","title":"Liquex.Tag.EchoTag","type":"module"},{"doc":"Repeatedly executes a block of code. For a full list of attributes available within a for loop, see forloop (object). Input { % for product in collection . products % } { { product . title } } { % endfor % } Output hat shirt pants else Specifies a fallback case for a for loop which will run if the loop has zero length. Input { % for product in collection . products % } { { product . title } } { % else % } The collection is empty . { % endfor % } Output The collection is empty. break Causes the loop to stop iterating when it encounters the break tag. Input { % for i in ( 1 .. 5 ) % } { % if i == 4 % } { % break % } { % else % } { { i } } { % endif % } { % endfor % } Output 1 2 3 continue Causes the loop to skip the current iteration when it encounters the continue tag. Input { % for i in ( 1 .. 5 ) % } { % if i == 4 % } { % continue % } { % else % } { { i } } { % endif % } { % endfor % } Output 1 2 3 5 for (parameters) limit Limits the loop to the specified number of iterations. Input &lt; ! -- if array = [ 1 , 2 , 3 , 4 , 5 , 6 ] -- &gt; { % for item in array limit : 2 % } { { item } } { % endfor % } Output 1 2 offset Begins the loop at the specified index. Input &lt; ! -- if array = [ 1 , 2 , 3 , 4 , 5 , 6 ] -- &gt; { % for item in array offset : 2 % } { { item } } { % endfor % } Output 3 4 5 6 To start a loop from where the last loop using the same iterator left off, pass the special word continue. Input &lt; ! -- if array = [ 1 , 2 , 3 , 4 , 5 , 6 ] -- &gt; { % for item in array limit : 3 % } { { item } } { % endfor % } { % for item in array limit : 3 offset : continue % } { { item } } { % endfor % } Output 1 2 3 4 5 6 range Defines a range of numbers to loop through. The range can be defined by both literal and variable numbers, and can be pulled from a variable. Input { % for i in ( 3 .. 5 ) % } { { i } } { % endfor % } { % assign num = 4 % } { % assign range = ( 1 .. num ) % } { % for i in range % } { { i } } { % endfor % } Output 3 4 5 1 2 3 4 reversed Reverses the order of the loop. Note that this flag’s spelling is different from the filter reverse. Input &lt; ! -- if array = [ 1 , 2 , 3 , 4 , 5 , 6 ] -- &gt; { % for item in array reversed % } { { item } } { % endfor % } Output 6 5 4 3 2 1","ref":"Liquex.Tag.ForTag.html","title":"Liquex.Tag.ForTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.ForTag.html#parse/0","title":"Liquex.Tag.ForTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.ForTag.html#parse_liquid_tag/0","title":"Liquex.Tag.ForTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.ForTag.html#render/2","title":"Liquex.Tag.ForTag.render/2","type":"function"},{"doc":"","ref":"Liquex.Tag.ForTag.html#render_collection/5","title":"Liquex.Tag.ForTag.render_collection/5","type":"function"},{"doc":"Executes a block of code only if a certain condition is true. Input { % if product . title == &quot;Awesome Shoes&quot; % } These shoes are awesome! { % endif % } Output These shoes are awesome!","ref":"Liquex.Tag.IfTag.html","title":"Liquex.Tag.IfTag","type":"module"},{"doc":"","ref":"Liquex.Tag.IfTag.html#else_tag/0","title":"Liquex.Tag.IfTag.else_tag/0","type":"function"},{"doc":"","ref":"Liquex.Tag.IfTag.html#elsif_tag/0","title":"Liquex.Tag.IfTag.elsif_tag/0","type":"function"},{"doc":"increment Creates and outputs a new number variable with initial value 0. On subsequent calls, it increases its value by one and outputs the new value. Input { % increment my_counter % } { % increment my_counter % } { % increment my_counter % } Output 0 1 2 Variables created using increment are independent from variables created using assign or capture. In the example below, a variable named “var” is created using assign. The increment tag is then used several times on a variable with the same name. Note that the increment tag does not affect the value of “var” that was created using assign. Input { % assign var = 10 % } { % increment var % } { % increment var % } { % increment var % } { { var } } Output 0 1 2 10 decrement Creates and outputs a new number variable with initial value -1. On subsequent calls, it decreases its value by one and outputs the new value. Input { % decrement variable % } { % decrement variable % } { % decrement variable % } Output - 1 - 2 - 3 Like increment, variables declared using decrement are independent from variables created using assign or capture.","ref":"Liquex.Tag.IncrementTag.html","title":"Liquex.Tag.IncrementTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.IncrementTag.html#parse/0","title":"Liquex.Tag.IncrementTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.IncrementTag.html#parse_liquid_tag/0","title":"Liquex.Tag.IncrementTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.IncrementTag.html#render/2","title":"Liquex.Tag.IncrementTag.render/2","type":"function"},{"doc":"","ref":"Liquex.Tag.IncrementTag.html#reverse_tags/5","title":"Liquex.Tag.IncrementTag.reverse_tags/5","type":"function"},{"doc":"liquid Encloses multiple tags within one set of delimiters, to allow writing Liquid logic more concisely. { % liquid case section . blocks . size when 1 assign column_size = &#39;&#39; when 2 assign column_size = &#39;one-half&#39; when 3 assign column_size = &#39;one-third&#39; else assign column_size = &#39;one-quarter&#39; endcase % } Because any tag blocks opened within a liquid tag must also be closed within the same tag, use echo to output data.","ref":"Liquex.Tag.LiquidTag.html","title":"Liquex.Tag.LiquidTag","type":"module"},{"doc":"Objects contain the content that Liquid displays on a page. Objects and variables are displayed when enclosed in double curly braces: {{ and }}. Input { { page . title } } Output Introduction In this case, Liquid is rendering the content of the title property of the page object, which contains the text Introduction.","ref":"Liquex.Tag.ObjectTag.html","title":"Liquex.Tag.ObjectTag","type":"module"},{"doc":"","ref":"Liquex.Tag.ObjectTag.html#close_object_remove_whitespace/0","title":"Liquex.Tag.ObjectTag.close_object_remove_whitespace/0","type":"function"},{"doc":"","ref":"Liquex.Tag.ObjectTag.html#filter/0","title":"Liquex.Tag.ObjectTag.filter/0","type":"function"},{"doc":"","ref":"Liquex.Tag.ObjectTag.html#filters/1","title":"Liquex.Tag.ObjectTag.filters/1","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.ObjectTag.html#parse/0","title":"Liquex.Tag.ObjectTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.ObjectTag.html#render/2","title":"Liquex.Tag.ObjectTag.render/2","type":"function"},{"doc":"Temporarily disables tag processing. This is useful for generating certain content that uses conflicting syntax, such as Mustache or Handlebars. Input { % raw % } In Handlebars , { { this } } will be HTML - escaped , but { { { that } } } will not . { % endraw % } Output In Handlebars , { { this } } will be HTML - escaped , but { { { that } } } will not .","ref":"Liquex.Tag.RawTag.html","title":"Liquex.Tag.RawTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.RawTag.html#parse/0","title":"Liquex.Tag.RawTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.RawTag.html#render/2","title":"Liquex.Tag.RawTag.render/2","type":"function"},{"doc":"Insert the rendered content of another template within the current template. { % render &quot;template-name&quot; % } Note that you don’t need to write the file’s .liquid extension. The code within the rendered template does not automatically have access to the variables assigned using variable tags within the parent template. Similarly, variables assigned within the rendered template cannot be accessed by code in any other template. render (parameters) Variables assigned using variable tags can be passed to a template by listing them as parameters on the render tag. { % assign my_variable = &quot;apples&quot; % } { % render &quot;name&quot; , my_variable : my_variable , my_other_variable : &quot;oranges&quot; % } One or more objects can be passed to a template. { % assign featured_product = all_products [ &quot;product_handle&quot; ] % } { % render &quot;product&quot; , product : featured_product % } with A single object can be passed to a template by using the with and optional as parameters. { % assign featured_product = all_products [ &quot;product_handle&quot; ] % } { % render &quot;product&quot; with featured_product as product % } In the example above, the product variable in the rendered template will hold the value of featured_product from the parent template. for A template can be rendered once for each value of an enumerable object by using the for and optional as parameters. { % assign variants = product . variants % } { % render &quot;product_variant&quot; for variants as variant % } In the example above, the template will be rendered once for each variant of the product, and the variant variable will hold a different product variant object for each iteration. When using the for parameter, the forloop object is accessible within the rendered template.","ref":"Liquex.Tag.RenderTag.html","title":"Liquex.Tag.RenderTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.RenderTag.html#parse/0","title":"Liquex.Tag.RenderTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.RenderTag.html#parse_liquid_tag/0","title":"Liquex.Tag.RenderTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.RenderTag.html#render/2","title":"Liquex.Tag.RenderTag.render/2","type":"function"},{"doc":"Generates an HTML table. Must be wrapped in opening &lt;table&gt; and closing loop, see tablerow (object). Input &lt; table &gt; { % tablerow product in collection . products % } { { product . title } } { % endtablerow % } &lt; / table &gt; Output &lt; table &gt; &lt; tr class = &quot;row1&quot; &gt; &lt; td class = &quot;col1&quot; &gt; Cool Shirt &lt; / td &gt; &lt; td class = &quot;col2&quot; &gt; Alien Poster &lt; / td &gt; &lt; td class = &quot;col3&quot; &gt; Batman Poster &lt; / td &gt; &lt; td class = &quot;col4&quot; &gt; Bullseye Shirt &lt; / td &gt; &lt; td class = &quot;col5&quot; &gt; Another Classic Vinyl &lt; / td &gt; &lt; td class = &quot;col6&quot; &gt; Awesome Jeans &lt; / td &gt; &lt; / tr &gt; &lt; / table &gt; tablerow (parameters) cols Defines how many columns the tables should have. Input { % tablerow product in collection . products cols : 2 % } { { product . title } } { % endtablerow % } Output &lt; table &gt; &lt; tr class = &quot;row1&quot; &gt; &lt; td class = &quot;col1&quot; &gt; Cool Shirt &lt; / td &gt; &lt; td class = &quot;col2&quot; &gt; Alien Poster &lt; / td &gt; &lt; / tr &gt; &lt; tr class = &quot;row2&quot; &gt; &lt; td class = &quot;col1&quot; &gt; Batman Poster &lt; / td &gt; &lt; td class = &quot;col2&quot; &gt; Bullseye Shirt &lt; / td &gt; &lt; / tr &gt; &lt; tr class = &quot;row3&quot; &gt; &lt; td class = &quot;col1&quot; &gt; Another Classic Vinyl &lt; / td &gt; &lt; td class = &quot;col2&quot; &gt; Awesome Jeans &lt; / td &gt; &lt; / tr &gt; &lt; / table &gt; limit Exits the tablerow loop after a specific index. { % tablerow product in collection . products cols : 2 limit : 3 % } { { product . title } } { % endtablerow % } offset Starts the tablerow loop after a specific index. { % tablerow product in collection . products cols : 2 offset : 3 % } { { product . title } } { % endtablerow % } range Defines a range of numbers to loop through. The range can be defined by both literal and variable numbers. &lt; ! -- variable number example -- &gt; { % assign num = 4 % } &lt; table &gt; { % tablerow i in ( 1 .. num ) % } { { i } } { % endtablerow % } &lt; / table &gt; &lt; ! -- literal number example -- &gt; &lt; table &gt; { % tablerow i in ( 3 .. 5 ) % } { { i } } { % endtablerow % } &lt; / table &gt;","ref":"Liquex.Tag.TablerowTag.html","title":"Liquex.Tag.TablerowTag","type":"module"},{"doc":"Callback implementation for Liquex.Tag.parse/0 .","ref":"Liquex.Tag.TablerowTag.html#parse/0","title":"Liquex.Tag.TablerowTag.parse/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.parse_liquid_tag/0 .","ref":"Liquex.Tag.TablerowTag.html#parse_liquid_tag/0","title":"Liquex.Tag.TablerowTag.parse_liquid_tag/0","type":"function"},{"doc":"Callback implementation for Liquex.Tag.render/2 .","ref":"Liquex.Tag.TablerowTag.html#render/2","title":"Liquex.Tag.TablerowTag.render/2","type":"function"},{"doc":"The opposite of if – executes a block of code only if a certain condition is not met. Input { % unless product . title == &quot;Awesome Shoes&quot; % } These shoes are not awesome . { % endunless % } Output These shoes are not awesome . This would be the equivalent of doing the following: { % if product . title != &quot;Awesome Shoes&quot; % } These shoes are not awesome . { % endif % }","ref":"Liquex.Tag.UnlessTag.html","title":"Liquex.Tag.UnlessTag","type":"module"},{"doc":"Liquex A Liquid template parser for Elixir. Liquid template renderer for Elixir with 100% compatibility with the Liquid gem by Shopify . If you find that this library is not byte for byte equivalent to liquid, please open an issue .","ref":"readme.html","title":"Liquex","type":"extras"},{"doc":"The package is available in Hex and can be installed by adding liquex to your list of dependencies in mix.exs : def deps do [ { :liquex , &quot;~&gt; 0.10.0&quot; } ] end Documentation can be found at https://hexdocs.pm/liquex .","ref":"readme.html#installation","title":"Liquex - Installation","type":"extras"},{"doc":"iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; { content , _context } = Liquex . render! ( template_ast , %{ &quot;name&quot; =&gt; &quot;World&quot; } ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot;","ref":"readme.html#basic-usage","title":"Liquex - Basic Usage","type":"extras"},{"doc":"As of Liquex v0.8, the library has unified how tag code is created. If you made any custom tags that did not follow the Custom Tags format, you will need to update them. That is because all tags now follow this standard.","ref":"readme.html#migrating-from-0-7-to-0-8","title":"Liquex - Migrating from 0.7 to 0.8","type":"extras"},{"doc":"Currently, all standard Liquid tags, filters, and types are fully supported for liquid up to and include Liquid 5. Liquex can be considered a byte for byte drop in replacement of the Liquid gem. Starting with version 0.10.0, Liquex now supports the following features: {% render %} tag {% liquid %} tag","ref":"readme.html#supported-features","title":"Liquex - Supported features","type":"extras"},{"doc":"Liquex allows resolver functions for variables that may require some extra work to generate. For example, Shopify has variables for things like available products. Pulling all products every time would be too expensive to do on every render. Instead, it would be better to lazily pull that information as needed. Instead of adding the product list to the context variable map, you can add a function to the variable map. If a function is accessed in the variable map, it is executed. products_resolver = fn _parent -&gt; Product . all ( ) end with { :ok , document } &lt;- Liquex . parse ( &quot;There are {{ products.size }} products&quot; ) , { result , _ } &lt;- Liquex . render! ( document , %{ products : products_resolver } ) do result end &quot;There are 5 products&quot;","ref":"readme.html#lazy-variables","title":"Liquex - Lazy variables","type":"extras"},{"doc":"By default, Liquex accesses your maps and structs that may have atom or string (or other type) keys. Liquex will try a string key first. If that fails, it will fall back to using an atom keys. This is similar to how Ruby on Rails handles many of its hashes. This allows you to pass in your structs without having to replace all your keys with string keys. iex&gt; { :ok , template_ast } = Liquex . parse ( &quot;Hello {{ name }}!&quot; ) iex&gt; { content , _context } = Liquex . render! ( template_ast , %{ name : &quot;World&quot; } ) iex&gt; content |&gt; to_string ( ) &quot;Hello World!&quot;","ref":"readme.html#indifferent-access","title":"Liquex - Indifferent access","type":"extras"},{"doc":"Liquex has a built in cache used specifically for the render tag currently. When loading a partial/sub-template using the render tag, it will try pulling from the cache associated with the context. By default, caching is disabled, but you may use the built in ETS based cache by configuring it in your context. :ok = Liquex.Cache.SimpleCache . init ( ) context = Context . new ( %{ ... } , cache : Liquex.Cache.SimpleCache ) The simple cache is by definition quite simple. To use a more complete caching system, such as Cachex , you can create a module that implements the Liquex.Cache behaviour. The cache system is very early on. It is expected that it will also be used to memoize some of the variables within your context.","ref":"readme.html#caching","title":"Liquex - Caching","type":"extras"},{"doc":"Liquex contains the full suite of standard Liquid filters, but you may find that there are still filters that you may want to add. Liquex supports adding your own custom filters to the render pipeline. When creating the context for the renderer, set the filter module to your own module. defmodule CustomFilter do # Import all the standard liquid filters use Liquex.Filter def scream ( value , _ ) , do : String . upcase ( value ) &lt;&gt; &quot;!&quot; end context = Liquex.Context . new ( %{ } , filter_module : CustomFilter ) { :ok , template_ast } = Liquex . parse ( &quot;{{&#39;Hello World&#39; | scream}}&quot; { result , _ } = Liquex . render! ( template_ast , context ) result |&gt; to_string ( ) iex&gt; &quot;HELLO WORLD!&quot;","ref":"readme.html#custom-filters","title":"Liquex - Custom filters","type":"extras"},{"doc":"One of the strong points for Liquex is that the tag parser can be extended to support non-standard tags. For example, Liquid used internally for the Shopify site includes a large range of tags that are not supported by the base Ruby gem. These tags could also be added to Liquex by extending the liquid parser. defmodule CustomTag do @moduledoc false @behaviour Liquex.Tag import NimbleParsec @impl true # Parse &lt;&lt;Custom Tag&gt;&gt; def parse ( ) do text = lookahead_not ( string ( &quot;&gt;&gt;&quot; ) ) |&gt; utf8_char ( [ ] ) |&gt; times ( min : 1 ) |&gt; reduce ( { Kernel , :to_string , [ ] } ) |&gt; tag ( :text ) ignore ( string ( &quot;&lt;&lt;&quot; ) ) |&gt; optional ( text ) |&gt; ignore ( string ( &quot;&gt;&gt;&quot; ) ) end @impl true def render ( contents , context ) do { result , context } = Liquex . render! ( contents , context ) { [ &quot;Custom Tag: &quot; , result ] , context } end end defmodule CustomParser do use Liquex.Parser , tags : [ CustomTag ] end iex&gt; document = Liquex . parse! ( &quot;&lt;&lt;Hello World!&gt;&gt;&quot; , CustomParser ) iex&gt; { result , _ } = Liquex . render! ( document , context ) iex&gt; result |&gt; to_string ( ) &quot;Custom Tag: Hello World!&quot;","ref":"readme.html#custom-tags","title":"Liquex - Custom tags","type":"extras"},{"doc":"Whitespace is kept in empty blocks For performance reasons, whitespace is kept within empty blocks such as for/if/unless. The liquid gem checks for &quot;blank&quot; renders and throws them away. Instead, we continue to use IO lists to combine the output and don't check for blank results to avoid too many conversions to strings. Since Liquid is mostly used for whitespace agnostic documents, this seemed like a decent tradeoff. If you need better whitespace control, use {%- , {{- , -%} , and -}} .","ref":"readme.html#deviations-from-original-liquid-gem","title":"Liquex - Deviations from original Liquid gem","type":"extras"}]